#include <bits/stdc++.h>
#include "testlib.h"
 
using namespace std;

using Graph = vector<set<int>>;
Graph ReadGraph() {
    int n = inf.readInt(1, 100000, "n");
    int m = inf.readInt(0, 100000, "m");
    Graph graph(n + 1);
    for (int i = 0; i < m; ++i) {
        int u = inf.readInt(1, n, "v");
        int v = inf.readInt(1, n, "u");
        graph[u].insert(v);
        graph[v].insert(u);
    }
    return graph;
}
 
int ReadAndCheckAnswer(InStream &in, const Graph& graph) {
    int n = static_cast<int>(graph.size()) - 1;
    int t = in.readInt(0, INT32_MAX, "t");
    in.quitif(t < 0, _wa, "Spent time cannot be negative");

    int k = in.readInt(2, 3 * n + 2, "k");
    vector<int> path;
    int cur_time = 0;
    for (int i = 0; i < k; ++i) {
        int nxt = in.readInt(1, n, "city");
        path.push_back(nxt);
        if (i + 1 < k) {
            string c = in.readToken("[+-]", "time_machine");
            in.quitif(c != "+" && c != "-", _wa, "Got unknown token");
            if (c == "+") {
                ++cur_time;
            } else {
                --cur_time;
            }
            in.quitif(cur_time < 0, _wa, "Route must always take nonnegative amount of hours at any point");
        }
    }
    in.quitif(t != cur_time, _wa, "Time from path does not match time in output");

    in.quitif(path.front() != 1, _wa, "Path does not start at city 1");
    in.quitif(path.back() != n, _wa, "Path does not end at city n");
    for (size_t i = 1; i < path.size(); ++i) {
        in.quitif(!graph[path[i - 1]].count(path[i]), _wa, "There is no railway between %d and %d", path[i - 1], path[i]);
    }
    return t;
}
 
int main(int argc, char *argv[]) {
    registerTestlibCmd(argc, argv);

    Graph graph = ReadGraph();
    
    int jury_spent_time = ReadAndCheckAnswer(ans, graph);
    int participant_spent_time = ReadAndCheckAnswer(ouf, graph);

    if (jury_spent_time < participant_spent_time) {
        quitf(_wa, "Jury has better answer: jans = %d, pans = %d", jury_spent_time, participant_spent_time);
    } else if (jury_spent_time == participant_spent_time) {
        quitf(_ok, "Answer = %d\n", jury_spent_time);
    } else {
        quitf(_fail, "Participant has better answer: jans = %d, pans = %d", jury_spent_time, participant_spent_time);
    }
}
