#include <bits/stdc++.h>
#include "testlib.h"
 
using namespace std;

vector<pair<int, int>> obfuscate(int n, vector<pair<int, int>> edges) {  // edges are 0-indexed
    vector<int> mapping(n);
    iota(mapping.begin(), mapping.end(), 1);
    shuffle(mapping.begin(), mapping.end());

    shuffle(edges.begin(), edges.end());
    for (auto& [u, v] : edges) {
        if (rnd.next(2)) {
            swap(u, v);
        }
        u = mapping[u];
        v = mapping[v];
    }
    return edges;
}

void print(int n, const vector<pair<int, int>>& edges) {
    cout << n << " " << edges.size() << endl;
    for (const auto& [u, v] : edges) {
        cout << u << " " << v << endl;
    }
}
 
int main(int argc, char *argv[]) {
    registerGen(argc, argv, 1);

    int n = opt<int>(1), m = opt<int>(2), t = opt<int>(3);
    vector<pair<int, int>> edges;
    set<pair<int, int>> edges_set;
    vector<int> p(n), color(n);
    color[0] = 0;
    for (int i = 1; i < n; ++i) {
        if (i > 0) {
            p[i] = rnd.wnext(i, t);
        }
        color[i] = 1 - color[p[i]];
        edges.emplace_back(p[i], i);
        edges_set.insert({p[i], i});
    }
    vector<vector<int>> parts(2);
    for (int i = 0; i < n; ++i) {
        parts[color[i]].push_back(i);
    }
    
    for (int i = n - 1; i < m; ++i) {
        int u = rnd.any(parts[0]);
        int v = rnd.any(parts[1]);
        if (u > v) {
            swap(u, v);
        }
        
        while (edges_set.count({u, v})) {
            u = rnd.any(parts[0]);
            v = rnd.any(parts[1]);
            if (u > v) {
                swap(u, v);
            }
        }
        edges_set.insert({u, v});
        edges.emplace_back(u, v);
    }
    
    edges = obfuscate(n, edges);
    print(n, edges);
}
