#include <bits/stdc++.h>
#include "testlib.h"
 
using namespace std;

vector<pair<int, int>> obfuscate(int n, vector<pair<int, int>> edges) {  // edges are 0-indexed
    vector<int> mapping(n);
    iota(mapping.begin(), mapping.end(), 1);
    shuffle(mapping.begin(), mapping.end());

    shuffle(edges.begin(), edges.end());
    for (auto& [u, v] : edges) {
        if (rnd.next(2)) {
            swap(u, v);
        }
        u = mapping[u];
        v = mapping[v];
    }
    return edges;
}

void print(int n, const vector<pair<int, int>>& edges) {
    cout << n << " " << edges.size() << endl;
    for (const auto& [u, v] : edges) {
        cout << u << " " << v << endl;
    }
}
 
int main(int argc, char *argv[]) {
    registerGen(argc, argv, 1);

    int p1 = opt<int>(1), p2 = opt<int>(2);
    vector<pair<int, int>> edges;
    for (int i = 0; i < p1; ++i) {
        for (int j = p1; j < p1 + p2; ++j) {
            edges.emplace_back(i, j);
        }
    }
    
    edges = obfuscate(p1 + p2, edges);
    print(p1 + p2, edges);
}
