#include "testlib.h"
#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <cstdio>
#include <numeric>
#include <cstring>
#include <ctime>
#include <cstdlib>
#include <set>
#include <map>
#include <unordered_map>
#include <unordered_set>
#include <list>
#include <cmath>
#include <bitset>
#include <cassert>
#include <queue>
#include <deque>
#include <cassert>
#include <iomanip>  
using namespace std;

const int MAXN = 5e5 + 1;

int n;
vector<int> e[MAXN];
vector<pair<int, int>> edges;

void postShuffle() {
	vector<int> perm;
	for (int i = 0; i <= n; i++) {
		perm.push_back(i);
	}
	shuffle(perm.begin() + 1, perm.end());
	shuffle(edges.begin(), edges.end());
	for (int i = 0; i < (int)edges.size(); i++) {
		int L = perm[edges[i].first], R = perm[edges[i].second];
		e[L].push_back(R);
		e[R].push_back(L);
	}
}

int parent[MAXN];

void dfs(int i, int p = 0) {
    parent[i] = p;
    for (int j: e[i]) {
        if (j == p) continue;
        dfs(j, i);
    }
}

void print() {
	postShuffle();
	dfs(rnd.next(1, n));
	printf("%d %d\n", n, n - 1);
	for (int i = 1; i <= n; ++i) {
	    if (parent[i] != 0) {
	        printf("%d %d\n", i, parent[i]);
	    }
	}
}

int main(int argc, char **argv) {
	registerGen(argc, argv, 1);
	n = rnd.next(1, atoi(argv[1]) / 2) * 2 + 1;
	int k = rnd.next(1, n - 1);
	for (int i = 2; i <= k; i++) {
		edges.push_back(make_pair(i - 1, i));
	}
	for (int i = k + 1; i <= n; i++) {
		edges.push_back(make_pair(k, i));
	}
	print();
}
