#include <bits/stdc++.h>
#include "testlib.h"
 
using namespace std;

vector<pair<int, int>> obfuscate(int n, vector<pair<int, int>> edges) {  // edges are 0-indexed
    vector<int> mapping(n);
    iota(mapping.begin(), mapping.end(), 1);
    shuffle(mapping.begin(), mapping.end());

    shuffle(edges.begin(), edges.end());
    for (auto& [u, v] : edges) {
        if (rnd.next(2)) {
            swap(u, v);
        }
        u = mapping[u];
        v = mapping[v];
    }
    return edges;
}

void print(int n, const vector<pair<int, int>>& edges) {
    cout << n << " " << edges.size() << endl;
    for (const auto& [u, v] : edges) {
        cout << u << " " << v << endl;
    }
}
 
int main(int argc, char *argv[]) {
    registerGen(argc, argv, 1);

    int n = opt<int>(1), m = opt<int>(2), t = opt<int>(3);
    set<pair<int, int>> edges_set;
    for (int i = 1; i < n; ++i) {
        int parent = rnd.wnext(i, t);
        edges_set.insert({parent, i});
    }
    
    for (int i = n - 1; i < m; ++i) {
        int u = 0, v = 1;
        do {
            u = rnd.next(0, n - 1);
            v = rnd.next(0, n - 1);
            if (u > v) {
                swap(u, v);
            }
        } while (u == v || edges_set.count({u, v}));
        edges_set.insert({u, v});
    }
    
    vector<pair<int, int>> edges(edges_set.begin(), edges_set.end());
    edges = obfuscate(n, edges);
    print(n, edges);
}
