#include <bits/stdc++.h>

using namespace std;
using Graph = vector<vector<int>>;

vector<int> FindPath(int start, int finish, const Graph& g) {
    if (start == finish) {
        return {start};
    }
    int n = static_cast<int>(g.size());
    vector<int> dist(n, n);
    vector<int> prev(n, -1);
    dist[start] = 0;
    queue<int> bfs;
    bfs.push(start);
    while (!bfs.empty()) {
        int cur = bfs.front();
        bfs.pop();
        for (int nxt : g[cur]) {
            if (dist[nxt] == n) {
                dist[nxt] = dist[cur] + 1;
                bfs.push(nxt);
                prev[nxt] = cur;
            }
        }
    }

    vector<int> path = {finish};
    while (prev[path.back()] != -1) {
        path.push_back(prev[path.back()]);
    }
    reverse(path.begin(), path.end());
    return path;
}

bool dfs(int cur, const Graph& g, vector<int>& color, vector<int>& stack) {
    stack.push_back(cur);
    for (int nxt : g[cur]) {
        if (color[nxt] == -1) {
            color[nxt] = 1 - color[cur];
            if (dfs(nxt, g, color, stack)) {
                return true;
            }
        } else if (color[nxt] == color[cur]) {
            stack.push_back(nxt);
            return true;
        }
    }
    stack.pop_back();
    return false;
}

vector<int> FindOddCycle(const Graph& g) {
    vector<int> color(g.size(), -1);
    vector<int> stack;

    color[0] = 0;
    if (dfs(0, g, color, stack)) {
        for (size_t i = 0; i < stack.size(); ++i) {
            if (stack[i] == stack.back()) {
                return vector<int>(stack.begin() + i, stack.end());
            }
        }
        return {};
    } else {
        return {};
    }
}

int main () {
    ios::sync_with_stdio(false);
    cin.tie(0);

    int n, m;
    cin >> n >> m;

    vector<vector<int>> g(n);
    for (int i = 0; i < m; ++i) {
        int u, v;
        cin >> u >> v;
        --u; --v;
        g[u].push_back(v);
        g[v].push_back(u);
    }

    vector<int> path = FindPath(0, n - 1, g);
    if ((path.size() - 1) % 2 == 1) {
        vector<int> odd_cycle = FindOddCycle(g);
        if (!odd_cycle.empty()) {
            path = FindPath(0, odd_cycle[0], g);
            vector<int> path2 = FindPath(odd_cycle.back(), n - 1, g);
            if ((path.size() + path2.size()) % 2 == 0) {
                for (size_t i = 1; i < path2.size(); ++i) {
                    path.push_back(path2[i]);
                }
            } else {
                for (size_t i = 1; i < odd_cycle.size(); ++i) {
                    path.push_back(odd_cycle[i]);
                }
                path.pop_back();
                for (int elem : path2) {
                    path.push_back(elem);
                }
            }
        }
    }

    cout << (path.size() - 1) % 2 << " " << path.size() << endl;
    cout << path[0] + 1;
    bool plus = true;
    for (size_t i = 1; i < path.size(); ++i) {
        cout << (plus ? " + " : " - ") << path[i] + 1;
        plus = !plus;
    }
    cout << endl;

    return 0;
}
