#include <bits/stdc++.h>
#include <random>

using namespace std;
using Graph = vector<vector<int>>;

bool dfs(int cur, int par, int finish, vector<int>& path, const Graph& g, mt19937& rng) {
    path.push_back(cur);
    if (cur == finish) {
        return true;
    }
    if (path.size() > g.size() * 3 + 2) {
        path.pop_back();
        return false;
    }
    vector<int> pos;
    for (int nxt : g[cur]) {
        if (nxt != par) {
            pos.push_back(nxt);
        }
    }
    shuffle(pos.begin(), pos.end(), rng);
    for (int nxt : pos) {
        if (dfs(nxt, cur, finish, path, g, rng)) {
            return true;
        }
    }
    path.pop_back();
    return false;
}

vector<int> FindPath(int start, int finish, const Graph& g, mt19937& rng) {
    vector<int> path;
    dfs(start, -1, finish, path, g, rng);
    return path;
}

int main () {
    ios::sync_with_stdio(false);
    cin.tie(0);

    int n, m;
    cin >> n >> m;

    mt19937 rng(random_device{}());

    vector<vector<int>> g(n);
    for (int i = 0; i < m; ++i) {
        int u, v;
        cin >> u >> v;
        --u; --v;
        g[u].push_back(v);
        g[v].push_back(u);
    }

    vector<int> path;
    for (int i = 0; i < 100; ++i) {
        path = FindPath(0, n - 1, g, rng);
        if (path.size() % 2 == 0) {
            break;
        }
    }


    cout << (path.size() - 1) % 2 << " " << path.size() << endl;
    cout << path[0] + 1;
    bool plus = true;
    for (size_t i = 1; i < path.size(); ++i) {
        cout << (plus ? " + " : " - ") << path[i] + 1;
        plus = !plus;
    }
    cout << endl;

    return 0;
}
