#include <algorithm>
#include <bits/stdc++.h>

using namespace std;

int main () {
    ios::sync_with_stdio(false);
    cin.tie(0);

    int n, m;
    cin >> n >> m;

    vector<vector<int>> g(n);
    for (int i = 0; i < m; ++i) {
        int u, v;
        cin >> u >> v;
        --u; --v;
        g[u].push_back(v);
        g[v].push_back(u);
    }

    vector<int> dist(n, n);
    vector<int> prev(n, -1);
    dist[0] = 0;
    queue<int> bfs;
    bfs.push(0);
    while (!bfs.empty()) {
        int cur = bfs.front();
        bfs.pop();
        for (int nxt : g[cur]) {
            if (dist[nxt] == n) {
                dist[nxt] = dist[cur] + 1;
                bfs.push(nxt);
                prev[nxt] = cur;
            }
        }
    }

    vector<int> path = {n - 1};
    while (prev[path.back()] != -1) {
        path.push_back(prev[path.back()]);
    }
    reverse(path.begin(), path.end());
    cout << (path.size() + 1) % 2 << " " << path.size() << endl;
    
    bool start = true;
    bool plus = false;
    for (int p : path) {
        if (!start) {
            cout << (plus ? " + " : " - ");
        }
        cout << p + 1;
        start = false;
        plus = !plus;
    }
    cout << endl;

    return 0;
}
